<?php
$options = Options::getAll();
if ($options['update_enabled'] != 1 && $_SESSION['forced_update'] != true)
    return;
$xml = "<serverCommand><name>PROGRAM-UPDATE</name><url>$options[update_url]</url><version>$options[update_version]</version></serverCommand>";
$neededVersion = $options['update_version'];
$db = Zend::registry('dbController');
/* Look for computers that need a update */
$select = $db->select()->from('computers');
if ($_SESSION['forced_update'] != true) {
    $select->where('last_update_notification+86400 < ?+1', time(0));
    $select->orWhere('last_update_notification is null');
}
$computers = $db->fetchAll($select);
$updateComputers = array();
//function checkVersion($currentVersion, $newVersion)
// Version examples 1.0.0.4RC3
// check if version1 is larger then version 2
//function checkVersion($version1, $version2) {
//    $pVersion1 = explode('.',$version1);
//    $pVersion2 = explode('.',$version2);
//    $iIsLarger = 0;
//    foreach ($pVersion1 as $int1) {
//        foreach ($p)
//    }
//}
/* Version1 is greater then version2 */
function compareVersions ($version1, $version2)
{
    return version_compare($version1, $version2);
}
foreach ($computers as $computer) {
    $cVersion = $computer['client_version'];
    //if ($neededVersion > $cVersion) {
    if (compareVersions($neededVersion, $cVersion) == 1) {
        $updateComputers[] = $computer['comp_guid'];
    }
}
foreach ($updateComputers as $compGuid) {
    $select = $db->select()->from('task_status')->where('computer_guid = ?', $compGuid)->where('task_status != ?', 'Stopped');
    $result = $db->fetchAll($select);
    if (count($result) > 0)
        continue;
    $insert = array("comp_guid" => "$compGuid" , "cmd_name" => "PROGRAM_UPDATE" , "status" => "pending" , "xml" => "$xml");
    $db->insert('cmdqueue', $insert);
    $db->update('computers', array("last_update_notification" => time(0)), $db->quoteInto('comp_guid = ?', $compGuid));
    Options::set('last_notification', time(0));
}
if ($_SESSION['forced_update'] == true)
    unset($_SESSION['forced_update']);