<?php

require_once('functions.php');
ob_start();
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Titan Backup Business Server: Web Installer</title>
<script src="jquery.js" type="text/javascript" charset="utf-8">
</script>
<style type="text/css" media="screen">
/*<![CDATA[*/
@import "style.css";
/*]]>*/
</style>
</head>

<body id="install_1">
<div id="header">
<div id="logo">
<h1>Titan Backup Business Server</h1>
<h2>Web Installer</h2>
</div>
</div>
<div id="menu">
<table id="steps">
	<tr>
		<td <?php if ($_GET['step'] == 1 || $_GET['step'] == ""): ?>
			class="current_nk" <?php endif; ?>>Step 1 - Permission Verifications</td>
		<td <?php if ($_GET['step'] == 2): ?> class="current_nk"
			<?php endif; ?>>Step 2 - Database Setup</td>
		<td <?php if ($_GET['step'] == 3): ?> class="current_nk"
			<?php endif; ?>>Step 3 - Site Setup</td>
		<td <?php if ($_GET['step'] == 4): ?> class="current_nk"
			<?php endif; ?>>Step 4 - Finish</td>
	</tr>
</table>
</div>

<div id="content">		
		<?php
		$pages = new Pages();
		switch ($_GET['step']) {
			case 1:
				$pages->checkPermissions();
				break;
			case 2:
				$pages->setupDatabase();
				break;
			case 3:
				$pages->setupSite();
				break;
			case 4:
			    $pages->finishPage();
			    break;
			default:
				$pages->checkPermissions();
				break;
		}
		?>
	</div>

<div id="footer">
<p>Titan Backup Business Server v2.0 - Copyright (c) 2008 Neobyte
Solutions. All Rights Reserved.</p>
</div>
</body>
</html>
<?php
ob_end_flush();
?>