<?php
/*
 * @todo Field nou la computer
 */
class Custom_ObjToTbt {
	public $daysToNumber = array ("Monday" => 1, "Tuesday" => 2, "Wednesday" => 3, "Thursday" => 4, "Friday" => 5, "Saturday" => 6, "Sunday" => 7 );
	public $numberToDays = array (1 => "Monday", 2 => "Tuesday", 3 => "Wednesday", 4 => "Thursday", 5 => "Friday", 6 => "Saturday", 7 => "Sunday" );
	public $span = false;
	public $taskTypes = array (0 => "floppy_folder", 1 => "local_folder", 2 => "lan_folder", 3 => "ftp_folder", 4 => "cd_folder", 10 => "sync_floppy", 11 => "sync_local", 12 => "sync_lan", 13 => "sync_ftp", 14 => "sync_floppy" );
	function xorCrypt($text, $key) {
		$tLen = strlen ( $text );
		$kLen = strlen ( $key );
		$kPos = 0;
		$newString = "";
		for($pos = 0; $pos < $tLen; $pos ++) {
			$tChr = ord ( substr ( $text, $pos, 1 ) );
			if ($kPos > $kLen - 1)
				$kPos = 0;
			$kChr = ord ( substr ( $key, $kPos, 1 ) );
			$newString .= chr ( $tChr ^ $kChr );
			$kPos ++;
		}
		return $newString;
	}
	function UnixTimeToDateTime($time) {
		// FIX FOR UNIX TIMESTAMPS
		return $time;
		$utime = $time;
		$tdUnixStartDate = 25569.0;
		return ($utime / 86400) + $tdUnixStartDate;
	}
	function DateTimeToUnixTime($time, $round = false) {
		$tdUnixStartDate = 25569.0;
		if ($round)
			return round ( $time - $tdUnixStartDate ) * 86400; else
			return ($time - $tdUnixStartDate) * 86400;
	}
	function DurationToDateTime($duration) {
		return $duration / 86400;
	}
	function DateTimeToDuration($datetime) {
		return $datetime * 86400;
	}
	function DaysToInt($aDays, $array = false) {
		$fDays = "";
		foreach ( $aDays as $day ) {
			$raDays [] = $this->daysToNumber ["$day"];
			$fDays .= $this->daysToNumber ["$day"];
		}
		return $array == false ? ( int ) $fDays : $raDays;
	}
	function parseVariables($string) {
		$variables = array ("%COMPUTERNAME%", "%WORKGROUP%" );
		$replacements = array ($this->computerName, $this->workgroup );
		return str_replace ( $variables, $replacements, $string );
	}
	function autoReseter($cIndex, &$array) {
		//$nextDay = $runDays[(($currentPos+1==$totalDays&&$schedTime<$currentTime)?$currentPos+2:$currentPos+1)<=$totalDays?$currentPos+1:0];
		reset ( $array );
		while ( current ( $array ) != $cIndex ) {
			each ( $array );
		}
		$nextBit = next ( $array );
		if ($nextBit == false) {
			$nextBit = reset ( $array );
			$nextBit = each ( $array );
			return $nextBit ["value"];
		}
		return $array [$nextBit];
	}
	function CalcNextRunTime($schedulerData, $lastRunTime = "NOW") {
		$minute = 60;
		$hour = 3600;
		$day = 3600 * 24;
		switch ( $schedulerData ["scheduleType"]) {
			case "manual" :
				return "Never.";
			break;
			case "onetime" :
				$fTime = $this->TimeToTDateTime ( $schedulerData ["oneTimeRunDate"], $schedulerData ["oneTimeRunTime"] );
				$otTime = $fTime ["udatetime"];
				$curTime = time ( 0 );
				if ($otTime < $curTime)
					return "Never."; else
					return strftime ( "%m/%d/%Y at %H:%M:00", $otTime );
			break;
			case "startup" :
				return "At Next Startup.";
			break;
			case "shutdown" :
				return "At ShutDown.";
			break;
			case "dayofweek" :
				// Build an array of our dates
				$currentDay = strftime ( "%A", time () );
				$currentDayNumber = ( int ) $this->daysToNumber ["$currentDay"];
				$runDays = $this->DaysToInt ( $schedulerData ["dayofweek_days"], true );
				foreach ( $runDays as $aIndex => $nextDay ) {
					if ($currentDayNumber <= $nextDay) {
						$nextDayPosition = $aIndex;
						break;
					}
					continue;
				}
				$dayDiff = ( int ) $nextDay - ( int ) $currentDayNumber;
				$currentTime = time ( 0 );
				$schedTime = strtotime ( $schedulerData ["dayofweek_runontime"] );
				if ($dayDiff == 0 && $schedulerData ["dayofweek_runtype"] == "ontime" && $schedTime < $currentTime) {
					$totalDays = sizeof ( $runDays ) - 1;
					$currentPos = $nextDayPosition;
					//                    $nextDay = $runDays[(($currentPos+1==$totalDays&&$schedTime<$currentTime)?$currentPos+2:$currentPos+1)<=$totalDays?$currentPos+1:0];
					$nextDay = $this->autoReseter ( $currentPos, $runDays );
				}
				$parsedSchedDate = date_parse ( date ( DATE_ISO8601, $schedTime ) );
				$sDate = $this->numberToDays [$nextDay];
				$nextRunTime = strtotime ( "$sDate +$parsedSchedDate[hour] hours +$parsedSchedDate[minute] minute" );
				if ($schedulerData ["dayofweek_runtype"] == "ontime")
					return strftime ( '%m/%d/%Y at %H:%M:00', $nextRunTime );
				if ($schedulerData ["dayofweek_runtype"] == "startup")
					return strftime ( '%m/%d/%Y at Startup', $nextRunTime );
				if ($schedulerData ["dayofweek_runtype"] == "shutdown")
					return strftime ( '%m/%d/%Y at ShutDown', $nextRunTime );
			break;
			case "runevery" :
				$oneDay = 86400;
				$schedTime = strtotime ( $schedulerData ["runevery_ontime"] );
				$currentTime = time ();
				$workingDays = $this->DaysToInt ( $schedulerData ["runevery_workingDays"], true );
				$currentDay = $this->daysToNumber [strftime ( "%A", time () )];
				foreach ( $workingDays as $aIndex => $nextDay ) {
					if ($currentDay <= $nextDay) {
						$nextDayPosition = $aIndex;
						break;
					}
					continue;
				}
				$dayDiff = ( int ) $nextDay - ( int ) $currentDay;
				if ($dayDiff == 0 && $schedulerData ["dayofweek_runtype"] == "ontime" && $schedTime < $currentTime) {
					$totalDays = sizeof ( $runDays ) - 1;
					$currentPos = $nextDayPosition;
					$nextDay = $this->autoReseter ( $currentPos, $workingDays );
				}
				
				/* Calculate extra Days */
                $addDays = 0;
                if ($schedTime < $currentTime)
                    $addDays = $schedulerData["runevery_days"];
                
                $nextTime = $schedTime;
                while (true) {
                    if ($addDays!=0)
                        $nextTime = strtotime("+$addDays days", $nextTime);

                    $nextDay = $this->daysToNumber[strftime("%A", $nextTime)];
                    if (in_array($nextDay, $workingDays)) break;
                    
                    $addDays += $schedulerData["runevery_days"];                    
                }
				
                if ($addDays != 0)
                    $schedTime = strtotime("+$addDays days", $schedTime);
                
                    $nextRunTime = $schedTime;
				if ($schedulerData ["runevery_runtype"] == "ontime")
					return strftime ( '%m/%d/%Y at %H:%M:00', $nextRunTime );
				if ($schedulerData ["runevery_runtype"] == "startup")
					return strftime ( '%m/%d/%Y at Startup', $nextRunTime );
				if ($schedulerData ["runevery_runtype"] == "shutdown")
					return strftime ( '%m/%d/%Y at ShutDown', $nextRunTime );
			break;
			case "runeveryhours" :
				if (( string ) $lastRunTime == "NOW")
					$lastRunTime = time ();
				$currentTime = time ();
				$currentDay = strftime ( "%A", time () );
				$currentDayNumber = ( int ) $this->daysToNumber ["$currentDay"];
				$runDays = $this->DaysToInt ( $schedulerData ["runeveryhours_workingDays"], true );
				foreach ( $runDays as $aIndex => $nextDay ) {
					if ($currentDayNumber <= $nextDay) {
						$nextDayPosition = $aIndex;
						break;
					}
					continue;
				}
				$dayDiff = ( int ) $nextDay - ( int ) $currentDayNumber;
				$scTime = date ( DATE_ISO8601, $currentTime );
				$hours = $schedulerData ["runeveryhours_hours"];
				$schedTime = strtotime ( "$scTime + $hours hours" );
				if ($dayDiff == 0 && $schedTime < $currentTime) {
					$totalDays = sizeof ( $runDays ) - 1;
					$currentPos = $nextDayPosition;
					//$nextDay = $runDays[(($currentPos+1==$totalDays&&$schedTime<$currentTime)?$currentPos+2:$currentPos+1)<=$totalDays?$currentPos+1:0];
					$nextDay = $this->autoReseter ( $currentPos, $runDays );
				}
				$parsedSchedDate = date_parse ( date ( DATE_ISO8601, $schedTime ) );
				$sDate = $this->numberToDays [$nextDay];
				$nextRunTime = strtotime ( "$sDate + $parsedSchedDate[hour] hours + $parsedSchedDate[minute] minutes" );
				return strftime ( "%m/%d/%Y at %H:%M:00", $nextRunTime );
			break;
			default :
				return "Never.";
			break;
		}
	}
	function TimeToTDateTime($date, $time) {
		//$parsedDate = date_parse($date);
		/* Explode the date, turn it into iso formating */
		list ( $day, $month, $year ) = explode ( '/', $date );
		$newDate = "$year-$month-$day $time";
		$parsedDate = date_parse ( $newDate );
		$unixDate = mktime ( 0, 0, 0, $parsedDate ["month"], $parsedDate ["day"], $parsedDate ["year"] );
		$unixDateTime = mktime ( $parsedDate ["hour"], $parsedDate ["minute"], 0, $parsedDate ["month"], $parsedDate ["day"], $parsedDate ["year"] );
		$tdDate = $this->UnixTimeToDateTime ( $unixDate );
		$tdDateTime = $this->UnixTimeToDateTime ( $unixDateTime );
		$fulldate = strftime ( "%m/%d/%Y %H:%M:00", $unixDateTime );
		return array ("date" => $tdDate, "datetime" => $tdDateTime, "fulldate" => $fulldate, "udatetime" => $unixDateTime );
	}
	function convert($object, $parse_variables = false, $setLastRunTime = NULL, $extraObjects = NULL) {
		$dObject = unserialize ( base64_decode ( $object ) );
		$dObject ["guid"] = 0;
		$xml = new SimpleXMLElement ( "<XML></XML>" );
		$xGeneral = $xml->addChild ( 'GENERAL' );
		$xType = $xGeneral->addChild ( 'Type', 0 );
		$xType->addAttribute ( 'bCount', 0 );
		$xType->addAttribute ( 'rCount', 0 );
		$xType->addAttribute ( 'bCountBig', 0 );
		$xGeneral->addChild ( 'Priority', 3 );
		$xGeneral->addChild ( 'Enabled', 'true' );
		$xGeneral->addChild ( 'Name', htmlentities ( $dObject ["task_general"] ["task_name"] ) );
		$xGeneral->addChild ( 'ArchiveFolderName', htmlentities ( $dObject ["task_general"] ["dest_name"] ) );
		$xGeneral->addChild ( 'Description', htmlentities ( $dObject ['task_general'] ["task_description"] ) );
		$xGeneral->addChild ( 'Email', $dObject ['task_general'] ["notification_email"] );
		/* These values are Static and need work */
		$xGeneral->addChild ( 'NextRunTime', $this->CalcNextRunTime ( $dObject ["task_scheduler"] ) );
		if ($setLastRunTime != NULL) {
			$xGeneral->addChild ( 'LastRunTime', $setLastRunTime );
		} else {
			$xGeneral->addChild ( 'LastRunTime', "Never." );
		}
		/*****************************************/
		$xCollision = $xGeneral->addChild ( 'SetCollision', $dObject ["task_options"] ["backupCreationType"] );
		$xCollision->addAttribute ( 'purge', $dObject ["task_options"] ["stackLastFiles"] == "" ? 3 : $dObject ["task_options"] ["stackLastFiles"] );
		$itemCollision = "full";
		if ($dObject ["task_options"] ["incrementalMode"] == "true" && $dObject ["task_options"] ["differentialMode"] != "true") {
			$itemCollision = "version";
		}
		$xGeneral->addChild ( 'ItemCollision', $itemCollision );
		$xGeneral->addChild ( 'SyncType', '' );
		$xGeneral->addChild ( 'SyncCollision', '' );
		$xStartRunPath = $xGeneral->addChild ( 'StartRunPath', $dObject ["task_events"] ["runBeforeCmd"] );
		$xEndRunPath = $xGeneral->addChild ( 'EndRunPath', $dObject ["task_events"] ["runAfterCmd"] );
		$xStartRunPath->addAttribute ( 'wait', 'false' );
		$xEndRunPath->addAttribute ( 'wait', 'false' );
		if ($dObject ['task_events'] ['notifySummary_showWindow'] == "true") {
			$xOnError = $xGeneral->addChild ( 'OnError-show', $dObject ['task_events'] ['notifySummary_showWindow'] == "true" ? 'Popup' : "" );
			$xOnError->addAttribute ( 'play', $dObject ["task_events"] ["notifyErrors_playSound"] == "true" ? "true" : "false" );
			$xOnError->addAttribute ( 'email', $dObject ["task_events"] ["notifyErrors_sendEmail"] == "true" ? "true" : "false" );
			$xOnWarning = $xGeneral->addChild ( 'OnWarning-show', $dObject ['task_events'] ['notifySummary_showWindow'] == "true" ? 'Popup' : "" );
			$xOnWarning->addAttribute ( 'play', $dObject ["task_events"] ["notifyWarnings_playSound"] == "true" ? "true" : "false" );
			$xOnWarning->addAttribute ( 'email', $dObject ["task_events"] ["notifyWarnings_sendEmail"] == "true" ? "true" : "false" );
			$xOnSummary = $xGeneral->addChild ( 'OnSummary-show', $dObject ['task_events'] ['notifySummary_showWindow'] == "true" ? 'Popup' : "" );
			$xOnSummary->addAttribute ( 'play', $dObject ["task_events"] ["notifySummary_playSound"] == "true" ? "true" : "false" );
			$xOnSummary->addAttribute ( 'email', $dObject ["task_events"] ["notifySummary_sendEmail"] == "true" ? "true" : "false" );
		} else {
			$xOnError = $xGeneral->addChild ( 'OnError-show', $dObject ['task_events'] ['notifyErrors_showWindow'] == "true" ? 'Popup' : "" );
			$xOnError->addAttribute ( 'play', $dObject ["task_events"] ["notifyErrors_playSound"] == "true" ? "true" : "false" );
			$xOnError->addAttribute ( 'email', $dObject ["task_events"] ["notifyErrors_sendEmail"] == "true" ? "true" : "false" );
			$xOnWarning = $xGeneral->addChild ( 'OnWarning-show', $dObject ['task_events'] ['notifyWarnings_showWindow'] == "true" ? 'Popup' : "" );
			$xOnWarning->addAttribute ( 'play', $dObject ["task_events"] ["notifyWarnings_playSound"] == "true" ? "true" : "false" );
			$xOnWarning->addAttribute ( 'email', $dObject ["task_events"] ["notifyWarnings_sendEmail"] == "true" ? "true" : "false" );
			$xOnSummary = $xGeneral->addChild ( 'OnSummary-show', $dObject ['task_events'] ['notifySummary_showWindow'] == "true" ? 'Popup' : "" );
			$xOnSummary->addAttribute ( 'play', $dObject ["task_events"] ["notifySummary_playSound"] == "true" ? "true" : "false" );
			$xOnSummary->addAttribute ( 'email', $dObject ["task_events"] ["notifySummary_sendEmail"] == "true" ? "true" : "false" );
		}
		if ($dObject ["task_scheduler"] ["scheduleType"] === "manual") {
			$xGeneral->addChild ( 'SNotScheduled', 'true' );
		} else {
			$xGeneral->addChild ( 'SNotScheduled', 'false' );
		}
		if ($dObject ["task_scheduler"] ["scheduleType"] === "onetime") {
			$oDate = $dObject ["task_scheduler"] ["oneTimeRunDate"];
			$oTime = $dObject ["task_scheduler"] ["oneTimeRunTime"];
			$oneTimeRunDate = $this->TimeToTDateTime ( $oDate, $oTime );
			$oneTimeRun = $xGeneral->addChild ( 'SOneTimeRun', $oneTimeRunDate ["datetime"] );
			$oneTimeRun->addAttribute ( "date", $oneTimeRunDate ["date"] );
			$oneTimeRun->addAttribute ( "time", $oneTimeRunDate ["datetime"] );
		} else {
			$oneTimeRun = $xGeneral->addChild ( 'SOneTimeRun' );
			$oneTimeRun->addAttribute ( 'date', 0 );
			$oneTimeRun->addAttribute ( 'time', 0 );
		}
		$scheduleType = $dObject ["task_scheduler"] ["scheduleType"];
		if ($scheduleType == "startup") {
			$xGeneral->addChild ( 'SWindowsStartup', 'true' );
		} else {
			$xGeneral->addChild ( 'SWindowsStartup', 'false' );
		}
		if ($scheduleType == "shutdown") {
			$xGeneral->addChild ( 'SWindowsShutDown', 'true' );
		} else {
			$xGeneral->addChild ( 'SWindowsShutDown', 'false' );
		}
		$xGeneral->addChild ( 'SFolderChange', 'false' );
		if ($dObject ["task_scheduler"] ["scheduleType"] == "runevery") {
			$xGeneral->addChild ( 'SDays', 'true' );
			$xGeneral->addChild ( 'SDays_days', $dObject ["task_scheduler"] ["runevery_days"] );
			switch ( $dObject ["task_scheduler"] ["runevery_runtype"]) {
				case "startup" :
					$xGeneral->addChild ( 'SDays_when', '0' );
				break;
				case "shutdown" :
					$xGeneral->addChild ( 'SDays_when', '1' );
				break;
				case "ontime" :
					$xGeneral->addChild ( 'SDays_when', '2' );
				break;
			}
			$nowDate = strftime ( "%d/%m/%Y", time ( 0 ) );
			$tdateTime = $this->TimeToTDateTime ( $nowDate, $dObject ['task_scheduler'] ['runevery_ontime'] );
			$xGeneral->addChild ( 'SDays_hour', $tdateTime ["datetime"] );
		} else {
			$xGeneral->addChild ( 'SDays', 'false' );
			if ($dObject ["task_scheduler"] ["scheduleType"] == "onetime")
				$xGeneral->addChild ( 'SDays_days', '1' ); else
				$xGeneral->addChild ( 'SDays_days', '0' );
			$xGeneral->addChild ( 'SDays_when', '0' );
			$xGeneral->addChild ( 'SDays_hour', '0' );
		}
		/* More Static Parts */
		if ($scheduleType === "dayofweek") {
			$xGeneral->addChild ( 'SWeeks', 'true' );
			$xGeneral->addChild ( 'SWeeks_days', $this->DaysToInt ( $dObject ["task_scheduler"] ["dayofweek_days"] ) );
			switch ( $dObject ["task_scheduler"] ["dayofweek_runtype"]) {
				case "startup" :
					$xGeneral->addChild ( 'SWeeks_when', '0' );
				break;
				case "shutdown" :
					$xGeneral->addChild ( 'SWeeks_when', '1' );
				break;
				case "ontime" :
					$xGeneral->addChild ( 'SWeeks_when', '2' );
				break;
			}
			$nowDate = strftime ( "%d/%m/%Y", time ( 0 ) );
			$tdateTime = $this->TimeToTDateTime ( $nowDate, $dObject ['task_scheduler'] ['dayofweek_runontime'] );
			$xGeneral->addChild ( 'SWeeks_hour', $tdateTime ["datetime"] );
		} else {
			$xGeneral->addChild ( 'SWeeks', 'false' );
			$xGeneral->addChild ( 'SWeeks_days', '1234567' );
			$xGeneral->addChild ( 'SWeeks_when', '0' );
			$xGeneral->addChild ( 'SWeeks_hour', '0' );
		}
		if ($scheduleType == "runevery") {
			$xGeneral->addChild ( 'SWork_days', $this->DaysToInt ( $dObject ["task_scheduler"] ["runevery_workingDays"] ) );
		} else {
			$xGeneral->addChild ( 'SWork_days', '1234567' );
		}
		/*********************/
		$xGeneral->addChild ( 'SRunMissed', $dObject ["task_scheduler"] ["rescheduleMissed"] == "" ? "false" : "true" );
		/* Yet some more static parts */
		$xGeneral->addChild ( 'CreateDate', time ( 0 ) ); //STATIC
		$xGeneral->addChild ( 'WorkingNow', 'false' );
		$xGeneral->addChild ( 'FormatDisk', 'false' );
		$xGeneral->addChild ( 'Split', $dObject ["task_options"] ["splitArchives"] == "" ? "false" : "true" );
		$xGeneral->addChild ( 'Span', ($this->span == true) ? "true" : "false" );
		$xGeneral->addChild ( 'MaxVolum', '0' );
		/* This needs to interpret differntial  */
		$xGeneral->addChild ( 'Complementary', $dObject ["task_options"] ["differentialMode"] == "true" ? 'true' : 'false' );
		$xGeneral->addChild ( 'EraseCD', 'false' );
		$xGeneral->addChild ( 'QuickErase', 'true' );
		if ($dObject ["task_scheduler"] ["scheduleType"] === "manual") {
			$xGeneral->addChild ( 'EnabledScheduler', 'false' );
		} else {
			$xGeneral->addChild ( 'EnabledScheduler', 'true' );
		}
		$tbtVersion = $xGeneral->addChild ( 'TBT_Version', '1.0.4' );
		$tbtVersion->addAttribute ( 'Simple', 'false' );
		/*******************************/
		$xGeneral->addChild ( 'TaskGUID', '{' . $dObject ['uuid'] . '}' );
		$shutdownAfter = "false";
		if ($dObject ["task_events"] ["shutdownAfter"] == "true")
			$shutdownAfter = "true";
		$logoffAfter = "false";
		if ($dObject ["task_events"] ["logoffAfter"] == "true")
			$logoffAfter = "true";
		$xGeneral->addChild ( 'ShutDown', $shutdownAfter );
		$xGeneral->addChild ( 'LogOff', $logoffAfter );
		/*Yet More Static Values*/
		$xGeneral->addChild ( 'SYNC_ByDateAndCRC', 'true' );
		$xGeneral->addChild ( 'SYNC_SyncAction', '0' );
		$xGeneral->addChild ( 'SYNC_SyncPrompt', '0' );
		$xGeneral->addChild ( 'SYNC_PromptDeleted', 'true' );
		$xGeneral->addChild ( 'SYNC_IgnoreDeleted', 'false' );
		$xGeneral->addChild ( 'SYNC_FolderToFolder', 'false' );
		/***********************/
		$xGeneral->addChild ( 'CreateDesktopShortcut', $dObject ['task_scheduler'] ['createShortcut'] == "" ? "false" : "true" );
		$xGeneral->addChild ( 'Scheduler_DelayedTime', '0' );
		if ($dObject ["task_events"] ["verifyBackup"] == "true") {
			$xGeneral->addChild ( 'VerifyBackup', 'true' );
		} else {
			$xGeneral->addChild ( 'VerifyBackup', 'false' );
		}
		if ($scheduleType == "runeveryhours") {
			$xGeneral->addChild ( 'SHours', 'true' );
			$nowDate = strftime ( "%d/%m/%Y", time ( 0 ) );
			$tdateTime = $this->TimeToTDateTime ( $nowDate, $dObject ['task_scheduler'] ['runeveryhours_time'] );
			//$tdateTime["datetime"]
			$xGeneral->addChild ( 'SHours_hours', $dObject ["task_scheduler"] ["runeveryhours_hours"] );
			$xGeneral->addChild ( 'SHours_hour', $tdateTime ["datetime"] );
			$xGeneral->addChild ( 'SHours_backups', $dObject ["task_scheduler"] ["runeveryhours_tasksperday"] );
			$xGeneral->addChild ( 'SHours_donebackups', '0' );
		} else {
			$xGeneral->addChild ( 'SHours', 'false' );
			$xGeneral->addChild ( 'SHours_hours', '0' );
			$xGeneral->addChild ( 'SHours_hour', '0' );
			$xGeneral->addChild ( 'SHours_backups', '0' );
			$xGeneral->addChild ( 'SHours_donebackups', '0' );
		}
		$xGeneral->addChild ( 'CountStacks', $dObject ["task_options"] ["stackFileLimit"] == "true" ? "true" : "false" );
		$xSource = $xml->addChild ( 'SOURCE' );
		$xSource->addChild ( 'AlsoFoldersMAsk', 'false' );
		$xSource->addChild ( 'ExcludeTemp', 'false' );
		$xSource->addChild ( 'InclusionMask' );
		$xSource->addChild ( 'ExclusionMask' );
		//$searchMasks $xSource->
		$searchMasks = $dObject ['task_source'] ['masks'];
		foreach ( $searchMasks as $description => $value ) {
			$searchMaskHolder = $xSource->addChild ( 'SearchMaskS' );
			$searchMaskChild = $searchMaskHolder->addChild ( 'SearchMask', "$value" );
			$searchMaskChild->addAttribute ( 'Description', $description );
		}
		$folders = $dObject ['task_source'] ['paths'];
		foreach ( $folders as $path ) {
			$pathInfo = pathinfo ( $path );
			if (! isset ( $pathInfo ["extension"] ))
				$xFolder = $xSource->addChild ( 'folder' ); else
				$xFolder = $xSource->addChild ( 'file' );
			$xFolder->addChild ( 'path', htmlentities ( stripslashes ( $path ) ) );
		}
		$xDestination = $xml->addChild ( 'DESTINATION' );
		if (is_array ( $extraObjects )) {
			$ftpContentVal = CompSpace::get ( $extraObjects ['computer'], $extraObjects ['task'], 'FTP_SOURCE' );
			//var_dump(base64_decode($ftpContentVal));
			if ($ftpContentVal != NULL) {
				$xml->addChild ( "FTP_SOURCE", "___FTPCONTENT___" );
				$this->ftpContent = base64_decode ( $ftpContentVal );
			}
		}
		$dType = $dObject ["task_options"] ["useCompression"] == "zip" ? 1 : 0;
		if ($dObject ["task_destination"] ["backupDestinationType"] == "local_folder") {
			$rb = 1;
			$root = $xDestination->addChild ( 'root' );
			$root->addAttribute ( 'dType', $dType );
			$root->addAttribute ( 'rb', $rb );
			/**
			 * @todo Fa ca in pathlist sa fie listat tot pathul
			 * @todo Fa ca in path sa fie listat doar primul path pana la ;
			 */
			if (strpos ( ';', $dObject ["task_destination"] ["localBackupFolder"] ) != false)
				$this->span = true;
			if ($parse_variables == true) {
				$path = stripslashes ( $this->parseVariables ( $dObject ["task_destination"] ["localBackupFolder"] ) );
				$ePaths = explode ( ";", $path );
				$root->addChild ( 'path', $ePaths [0] );
				$root->addChild ( 'pathlist', $path );
			} else {
				$ePaths = explode ( ';', $dObject ["task_destination"] ["localBackupFolder"] );
				$root->addChild ( 'path', stripslashes ( $ePaths [0] ) );
				$root->addChild ( 'pathlist', stripslashes ( $dObject ["task_destination"] ["localBackupFolder"] ) );
			}
		}
		if ($dObject ["task_destination"] ["backupDestinationType"] == "lan_folder") {
			$rb = 2;
			$root = $xDestination->addChild ( 'root' );
			$root->addAttribute ( 'dType', $dType );
			$root->addAttribute ( 'rb', $rb );
			if ($parse_variables == true) {
				$path = stripslashes ( $this->parseVariables ( $dObject ["task_destination"] ["lanBackupFolder"] ) );
				$root->addChild ( 'path', $path );
				$root->addChild ( 'pathlist', $path );
			} else {
				$path = $root->addChild ( 'path', stripslashes ( $dObject ["task_destination"] ["lanBackupFolder"] ) );
				$root->addChild ( 'pathlist', stripslashes ( $dObject ["task_destination"] ["lanBackupFolder"] ) );
			}
			if ($dObject ["task_destination"] ["lanBackupFolderUser"] !== "") {
				$root->addChild ( 'username', $dObject ["task_destination"] ["lanBackupFolderUser"] );
				$root->addChild ( 'password', base64_encode ( $this->xorCrypt ( $dObject ["task_destination"] ["lanBackupFolderPasword"], 'tbescrypter' ) ) );
			}
		}
		if ($dObject ["task_destination"] ["backupDestinationType"] == "ftp_folder") {
			$rb = 3;
			$root = $xDestination->addChild ( 'root' );
			$root->addAttribute ( 'dType', $dType );
			$root->addAttribute ( 'rb', $rb );
			$root->addChild ( 'pathlist', 'path' );
			//$path = $root->addChild('path', stripslashes($dObject["task_destination"]["lanBackupFolder"]));
			$root->addChild ( 'connName' );
			$root->addChild ( 'Host', $dObject ["task_destination"] ["ftpHostname"] );
			$root->addChild ( 'Port', $dObject ["task_destination"] ["ftpPort"] );
			$root->addChild ( 'UserName', $dObject ["task_destination"] ["ftpUsername"] );
			$root->addChild ( 'Pass', base64_encode ( $this->xorCrypt ( $dObject ["task_destination"] ["ftpPassword"], 'tbescrypter' ) ) );
			if ($parse_variables == true) {
				$root->addChild ( 'InitDir', $this->parseVariables ( $dObject ["task_destination"] ["ftpInitDir"] ) );
			} else {
				$root->addChild ( 'InitDir', $dObject ["task_destination"] ["ftpInitDir"] );
			}
			$root->addChild ( 'PsvMode', $dObject ["task_destination"] ["ftpPassiveMode"] == "true" ? "true" : "false" );
			$root->addChild ( 'SavProx', 'false' );
			$root->addChild ( 'ProxyHost' );
			$root->addChild ( 'ProxyPort' );
			$root->addChild ( 'ProxyUN' );
			$root->addChild ( 'ProxyPass' );
			$root->addChild ( 'ProxyMeth' );
		}
		if ($dObject ["task_options"] ["useCompression"] == "zip") {
			$archive = $xDestination->addChild ( 'archive', "true" );
			if ($this->span == true)
				$archive->addAttribute ( 'span', 'true' );
				//Zend::dump ( $dObject );
			$archive->addAttribute ( 'quality', $dObject ["task_options"] ["compressionLevel"] );
			if ($dObject ["task_options"] ["selfExtracting"] == "true") {
				$archive->addAttribute ( "selfextracting", "true" );
			} else {
				$archive->addAttribute ( "selfextracting", "false" );
			}
			if ($dObject ["task_options"] ["useEncryption"] == "zip") {
				$archive->addAttribute ( 'security', 'Zip' );
				$archive->addAttribute ( 'password', base64_encode ( $this->xorCrypt ( $dObject ["task_options"] ["encryptionPassword"], 'tbescrypter' ) ) );
			}
			if ($dObject ["task_options"] ["useEncryption"] == "aes") {
				$archive->addAttribute ( 'security', 'AES' );
				$archive->addAttribute ( 'password', base64_encode ( $this->xorCrypt ( $dObject ["task_options"] ["encryptionPassword"], 'tbescrypter' ) ) );
				$archive->addAttribute ( "selfextracting", "false" );
			}
			if ($dObject ["task_options"] ["splitArchives"] == "true") {
				$archive->addAttribute ( "split", bcmul ( $dObject ["task_options"] ["splitArchivesAt"], 1048576 ) );
			}
		} else {
			$archive = $xDestination->addChild ( 'archive', "false" );
		}
		$list = $xDestination->addChild ( 'list' );
		$list->addAttribute ( 'VerifyMedium', 'false' );
		if (is_array ( $extraObjects )) {
			$stackVal = CompSpace::get ( $extraObjects ['computer'], $extraObjects ['task'], 'st' );
			$zipNamesVal = CompSpace::get ( $extraObjects ['computer'], $extraObjects ['task'], 'ZipNames' );
			if ($stackVal != NULL) {
				$xDestination->addChild ( "st", "___STACKCONTENT___" );
				$this->stackContent = base64_decode ( $stackVal );
			}
			if ($zipNamesVal != NULL) {
				$zipNames = $xDestination->addChild ( 'ZipNames', "___ZIPCONTENT___" );
				$this->zipContent = base64_decode ( $zipNamesVal );
			}
		}
		$registry = $xml->addChild ( 'REGISTRY' );
		$registryKeys = $dObject ['task_source'] ['registryPaths'];
		foreach ( $registryKeys as $key ) {
			$xKey = $registry->addChild ( 'key' );
			$xKey->addChild ( 'name', $key );
			$xKey->addChild ( 'path', $key );
		}
		$plugins = $xml->addChild ( 'PLUGINS' );
		foreach ( $dObject ["task_source"] ['selectedPlugins'] as $plugin ) {
			$child = $plugins->addChild ( 'plugin' );
			$child->addChild ( 'guid', $plugin );
			$child->addChild ( 'files' );
			$child->addChild ( 'idents' );
		}
		$xml->addChild ( 'UserCategory', '0' );
		/*return(str_replace('<?xml version="1.0"?>', '', $xml->asXML()));*/
		$result = $xml->asXML ();
		$replaceSearch = array ("___ZIPCONTENT___", "___FTPCONTENT___", "___STACKCONTENT___" );
		$replaceWith = array ($this->zipContent, $this->ftpContent, $this->stackContent );
		$result = str_replace ( $replaceSearch, $replaceWith, $result );
		$doc = new DOMDocument ( '1.0' );
		$doc->formatOutput = true;
		$domnode = dom_import_simplexml ( simplexml_load_string ( $result ) );
		$domnode = $doc->importNode ( $domnode, true );
		$domnode = $doc->appendChild ( $domnode );
		return (str_replace ( '<?xml version="1.0"?>', '', $doc->saveXML () ));
	}
}