var nTree = {
    init: function() {
        collapseAllRows();
        nTree.bindEvents();
        $$(".tier1").setStyle('background-position','0.5em center');
        $$(".tier2").setStyle('background-position','1.7em center');
        $$(".tier3").setStyle('background-position','2.2em center');

    },
    bindEvents: function() {
        collapsables = $$(".collapseableX");
        collapsables.each(function(el) {
            el.onclick = function(){ toggleRows(this);}
            el.treeWise = {selected: false, parent: null} ;
        });
        collapsables2 = $$(".collapseable");
        collapsables2.each(function(el) {
            if ($(el).getElementsBySelector("a").length == 0) {
                el.onclick = function(){ toggleRowsN(this);}
                el.treeWise = {selected: false, parent: null} ;
            }

        });
    },
    popApplyManager: function(task_id) {
        window.open("/tasks/rules/task_id/" + task_id ,'','width=600,height=515');
    },
    popEditManager: function(rule_id) {
        window.open("/tasks/rules/edit/" + rule_id ,'','width=600,height=515');
    }


}


function toggleRows(elm) {
    var rows = document.getElementsByTagName("TR");
    //elm.parentNode.style.backgroundImage = "url(/themes/default/images/plusik.gif)";
    elm.childNodes[0].src = "/themes/default/images/plusik.gif";

    var newDisplay = "none";
    var thisID = elm.parentNode.parentNode.id + "-";
    // Are we expanding or contracting? If the first child is hidden, we expand
    for (var i = 0; i < rows.length; i++) {
        var r = rows[i];
        if (matchStart(r.id, thisID, true)) {
            if (r.style.display == "none") {
                if (document.all) newDisplay = "block"; //IE4+ specific code
                else newDisplay = ""; //Netscape and Mozilla
                elm.childNodes[0].src = "/themes/default/images/minus.gif";
                //          elm.parentNode.style.backgroundImage = "url(/themes/default/images/minus.gif)";
            }
            break;
        }
    }

    // When expanding, only expand one level.  Collapse all desendants.
    var matchDirectChildrenOnly = (newDisplay != "none");

    for (var j = 0; j < rows.length; j++) {
        var s = rows[j];
        if (matchStart(s.id, thisID, matchDirectChildrenOnly)) {
            s.style.display = newDisplay;
            var cell = s.getElementsByTagName("TD")[0];
            if (cell.getAttribute("onclick") != null) {
                cell.style.backgroundImage = "url(/themes/default/images/plusik.gif)";
            }
        }
    }
}

function toggleRowsN(elm) {
    var rows = document.getElementsByTagName("TR");
    elm.style.backgroundImage = "url(/themes/default/images/plusik.gif)";
    var newDisplay = "none";
    var thisID = elm.parentNode.id + "-";
    // Are we expanding or contracting? If the first child is hidden, we expand
    for (var i = 0; i < rows.length; i++) {
        var r = rows[i];
        if (matchStart(r.id, thisID, true)) {
            if (r.style.display == "none") {
                if (document.all) newDisplay = "block"; //IE4+ specific code
                else newDisplay = ""; //Netscape and Mozilla
                elm.style.backgroundImage = "url(/themes/default/images/minus.gif)";
            }
            break;
        }
    }

    // When expanding, only expand one level.  Collapse all desendants.
    var matchDirectChildrenOnly = (newDisplay != "none");

    for (var j = 0; j < rows.length; j++) {
        var s = rows[j];
        if (matchStart(s.id, thisID, matchDirectChildrenOnly)) {
            s.style.display = newDisplay;
            var cell = s.getElementsByTagName("TD")[0];
            if (cell.getAttribute("onclick") != null) {
                cell.style.backgroundImage = "url(/themes/default/images/plusik.gif)";
            }
        }
    }
}



function getTreeParents(element) {
    elId = element.id;
    treeParents = elId.split('-');
    finalParents = new Array();
    if ((treeParents.length-2) == -1) return false;

    for (i=treeParents.length-2;i>=0;i--) {
        if ((i + (treeParents.length-1)) == treeParents.length -1) {
            finalParents.push(treeParents[i]);
        } else {
            finalParents.push(treeParents[i] + '-' + '0');
        }
    }
    return finalParents;
}

function matchStart(target, pattern, matchDirectChildrenOnly) {
    var pos = target.indexOf(pattern);
    if (pos != 0) return false;
    if (!matchDirectChildrenOnly) return true;
    if (target.slice(pos + pattern.length, target.length).indexOf("-") >= 0) return false;
    return true;
}

function collapseAllRows() {
    var rows = document.getElementsByTagName("TR");
    for (var j = 0; j < rows.length; j++) {
        var r = rows[j];
        d = $(r).getFirst();
        if ($(d).hasClass('collapseable')) {
            d.style.backgroundImage = "url(/themes/default/images/plusik.gif)";
        }

        if (r.id.indexOf("-") >= 0) {
            r.style.display = "none";
        }
    }
}

function expandAllRows() {
    var rows = document.getElementsByTagName("TR");
    for (var j = 0; j < rows.length; j++) {
        var r = rows[j];
        d = $(r).getFirst();
        if ($(d).hasClass('collapseable')) {
            d.style.backgroundImage = "url(/themes/default/images/minus.gif)";
        }
        if (r.id.indexOf("-") >= 0) {
            r.style.display = "";
        }
    }
}


function expandAllRowsClean() {
    $$(".collapseableX").each(function(el,key){toggleRows(el);});
}





window.addEvent('domready', nTree.init);