<?php
/**
 * Blank controller intended for management of the computers section
 * 
 * @author Nophinity
 * @version 0.0
 * @todo Finish it
 * @see Zend_Controller_Action
 * 
 */
class ComputersController extends Zend_Controller_Action
{
    /**
     * Responsible for invoking the main action
     * now it just displays the generic list_computers template.
     *
     */
    function IndexAction ()
    {
        $smarty = new Custom_Smarty('Computers', 'list_computers.tpl', 'mainTemplate.tpl', 'computersSubmenu.tpl');
        $action = $_POST["computer_action"];
        $list = $_POST["selected_computers"];
        $db = Zend::registry('dbController');
        $smarty->assign('currentTime', time(0));
        switch ($action) {
            case "delete":
                foreach ($list as $key) {
                    $where = $db->quoteInto('comp_guid = ?', $key);
                    $db->delete('computers', $where);
                }
                break;
            case "approve":
                foreach ($list as $key) {
                    $where = $db->quoteInto('comp_guid = ?', $key);
                    $row = array("status" => "approved");
                    $db->update('computers', $row, $where);
                }
                break;
        }
        $search = $_POST["search_tasks"];
        $select = $db->select()->from('computers');
        if ($this->_getParam('list') == "pending")
            $select->where('status = ?', 'pending');
        $smarty->assign('sortType', $_GET['sorttype'] == "ASC" ? "DESC" : "ASC");
        if ($_GET['sortby'] != "") {
            if ($_GET['sortby'] == "online") {
                $_GET['sortby'] = 'last_update';
                $smarty->assign('sortby', 'online');
            } else {
                $smarty->assign('sortby', $_GET['sortby']);
            }
            $select->order("$_GET[sortby] $_GET[sorttype]");
        }
        if ($search != "")
            $select->where('computer_name = ?', $search);
        $result = $db->fetchAll($select);
        $nResult = array();
        foreach ($result as $computer) {
            $lSelect = $db->select()->from('task_status')->where('computer_guid = ?', $computer["comp_guid"]);
            $lSelect->order(array("sid DESC"))->where('task_status = ?', 'Stopped');
            $row = $db->fetchRow($lSelect);
            $computer["lastRunTime"] = NULL;
            $computer["lastRunTask"] = NULL;
            $computer["lastRunTaskId"] = NULL;
            if ($row != false) {
                $computer["lastRunTime"] = $row["last_run_time"];
            }
            ;
            if ($row == false) {
                $computer["lastRunTask"] == "None.";
            }
            if ($row == false) {
                $computer["lastRunTime"] == "Never.";
            }
            if ($row != false) {
                $task = $db->fetchRow("SELECT * FROM tasks WHERE guid = '$row[guid]';");
                $computer["lastRunTask"] = $task["task_name"];
                $computer["lastRunTaskId"] = $task["id"];
            }
            $nResult[] = $computer;
        }
        $smarty->assign('refresh_time', Options::get('refresh_time'));
        $smarty->assign('computer_list', $nResult);
        $smarty->dumpT();
    }
}