<?php
//include ('../../init.php');
$db = Zend::registry('dbController');
//$db->delete('task_status', 'update_time+(60*5) < CURRENT_TIMESTAMP;');
$config = Zend::registry('databaseConfig');
$engine = $config->engine;
switch ($engine) {
    case 'mysql':
        $select = $db->select()->from('task_status')->where('(UNIX_TIMESTAMP(CURRENT_TIMESTAMP)-UNIX_TIMESTAMP(update_time))>300')->where('task_status != ?', 'Stopped');
        break;
    case 'sqlite':
        $select = $db->select()->from('task_status')->where('(strftime("%s", CURRENT_TIMESTAMP)-strftime("%s", update_time))>300')->where('task_status != ?', 'Stopped');
        break;
    default:
        break;
}
try {
    $rows = $db->fetchAll($select);
} catch (Exception $e) {
    Zend::dump($e);
}
//echo($select);
//Zend::dump($rows);
foreach ($rows as $task) {
    Logger::Log(4, 2, $task['task_guid'], $task['computer_guid'], "Task terminated by server", "Task terminated by server for not responding, and being in idle for 5 minutes." . "\nTechnical details follow:\n" . var_export($task, true));
    $db->update('task_status', array("task_status" => "Stopped" , "update_time" => $task['update_time'] , "task_progress" => 0), $db->quoteInto('sid = ?', $task['sid']));
    // E comentat ca sa vad ce se intampla in caz de update :P
// $db->delete('task_status', $db->quoteInto('sid = ?', $task['sid']));
}

//$db->delete('task_status', "update_time+(60*5) < NOW()");
