<?php
/**
 * The main layout initialization package
 *
 * @author Nophinity
 * @package TBES
 */
require ('init.php');
function dateTimeSelect ($el, $as = NULL)
{
    $db = Zend::registry('databaseConfig');
    if ($db->engine == "sqlite") {
        $asel = $as == NULL ? $el : $as;
        return "DATETIME($el, 'localtime') AS $asel";
    } else
        return "$el";
}
Custom_Debug::printDebug(Zend::dump($_SESSION, null, false));
Custom_Debug::printDebug(Zend::dump($_POST, null, false));
Custom_Debug::printDebug(Zend::dump($_GET, null, false));
$authString = md5($_SERVER['PHP_AUTH_USER'] . ":" . $_SERVER['PHP_AUTH_PW']);
$reqAuthString = Options::get('authString');
$oAdminEmail = Options::get('admin_email');
//        $reqAuthString = Options::set('authString', md5('admin:admin'));
if ($oAdminEmail == NULL) {
    Options::set('admin_email', $siteConfig->adminEmail);
}
if ($reqAuthString == NULL) {
    if ($siteConfig->authString != NULL) {
        $reqAuthString = Options::set('authString', (string) $siteConfig->authString);
    } else {
        $reqAuthString = Options::set('authString', md5('admin:admin'));
    }
}
if ($reqAuthString != $authString) {
    $_SESSION['needAuth'] = true;
} else {
    $_SESSION['needAuth'] = false;
}
$dispatch = $siteController->dispatch();
$request = $siteController->getRequest();
$controllerName = strtolower($request->getControllerName());
$actionName = strtolower($request->getActionName());
//if (($controllerName != "tasks" && $controllerName != "json") || $actionName == "index") {
if (($controllerName != "tasks" && $controllerName != "json") || $actionName == "index" || $actionName == "list") {
    unset($_SESSION["save"]);
    unset($_SESSION["edit"]);
    unset($_SESSION["update"]);
    unset($_SESSION["prevItem"]);
    unset($_SESSION["readonly"]);
}
/* Get cron to only run every minute, instead of every page load */
$cron = Options::get('cronrun');
$nTime = time(0);
//printf("cron+60 < nTime = %d+60 < %d = %d < %d = %d", $cron, $nTime, $cron + 60, $nTime, $cron+60<$nTime);
if ($cron === null)
    Options::set('cronrun', $nTime);
if ($cron + 60 < $nTime) {
    include ('cron/pseudo-cron.inc.php');
    Options::set('cronrun', $nTime);
}
/* End */
if ($controllerName == "xml" && $DEBUG_MODE == "logs") {
    $fd = fopen("debug.log", "a");
    $log = "================================" . date(DATE_ISO8601, time()) . "================================\n";
    $log .= "Controller Name: " . $controllerName . "\n";
    $log .= "Action Name: " . $actionName . "\n";
    if ($controllerName == "xml") {
        $log .= "\nXML Data:\n" . urldecode($_POST["XML"]);
        $log .= "\nXML DataN:\n" . $_POST["XML"];
    } else {
        $log .= "Data POST: \n" . var_export($_POST, true);
        $log .= "\nData Get: \n" . var_export($_GET, true);
    }
    $log .= "\n================================" . "END" . "================================\n";
    fwrite($fd, $log);
    fclose($fd);
}