<?php
class CompSpace
{
    static public function set ($computer, $task, $key, $value)
    {
        $db = Zend::registry('dbController');
        $select = $db->select()->from('computer_variables')->where('var_name = ?', $key);
        $select->where("comp_guid = ?", $computer);
        $select->where('task_guid = ?', $task);
        $result = $db->fetchRow($select);
        if ($result == false) {
            $db->insert('computer_variables', array("var_name" => $key , "value" => $value, "comp_guid" => "$computer", "task_guid" => "$task"));
        } else {
            $where = $db->quoteInto("var_name = ?", $key) . " AND " . $db->quoteInto("task_guid = ?", $task);
            $where .= " AND " . $db->quoteInto('comp_guid = ?', $computer);
            $db->update('computer_variables', array("value" => $value), $where);
        }
        return $value;
    }
    static public function get ($computer, $task, $key)
    {
        $db = Zend::registry('dbController');
        $select = $db->select()->from('computer_variables')->where('var_name = ?', $key);
        $select->where('comp_guid = ?', $computer);
        $select->where('task_guid = ?', $task);
        $result = $db->fetchRow($select);
        if ($result != false)
            return $result["value"];
        return NULL;
    }
}