<?php
class Custom_Mail
{
    public static function newComputerMail ($insert)
    {
        $mail = new Zend_Mail();
        $text = <<<_EOF_
A new computer has just registered into the Titan Backup Business Server.


Computer Nane: {$insert["computer_name"]}
Workgroup: {$insert["workgroup"]}
IP: {$insert["ip"]}


Please login into the Administration Console and approve this computer.

_EOF_;
        $mail->setBodyText($text);
        $mail->setFrom('tbbs@neobytesolutions.com', 'Titan Backup Business Server Alerts');
        $mail->addTo(Options::get('admin_email'));
        $mail->setSubject("A new computer has registered.");
        try {
            $ret = $mail->send();
        } catch (Exception $e) {
            Custom_Debug::printDebug($e->getMessage());
        }
        return $ret;
    }
}