{*<script type="text/javascript">
{literal}
function toggleDate(elm) {
    if (elm.checked == true) {
        $('relativeDate').setStyle('display', 'none');
        $('absoluteDate').setStyle('display', '');        
    } else {
        $('relativeDate').setStyle('display', '');
        $('absoluteDate').setStyle('display', 'none');                
    }
}
{/literal}
</script>*}

<h2>{$ls.logs}</h2>

<div class="filters" id="reportFilters">
<form class="filters" name="filters" method="post">
<p>
{if $hideFilterType != true}
<label class="bigLabel">{$ls.logTypes}: 
<select name="filters[log_type]">
<option value="-1" {if $filters.log_type == -1}selected{/if}>{$ls.all}</option>
{section name=logloop loop=$logTypes}
<option value="{$logTypes[logloop].id}" {if $logTypes[logloop].id == $filters.log_type}selected{/if}>{$logTypes[logloop].name}</option>
{/section}
</select>
</label>
{/if}

{if $hideStatusFilter != true}
<label class="bigLabel">{$ls.status}: 
<select name="filters[status]">
<option value="-1" {if $filters.status == -1}selected{/if}>{$ls.all}</option>
{foreach name=statusloop from=$status key=status_id item=status_name}
<option value="{$status_id}" {if $status_id == $filters.status}selected{/if}>{$status_name}</option>
{/foreach}
</select>
</label>
{/if}

{*<span id="relativeDate" {if $filters.absolutedate == "true"}style="display: none;"{/if}>
<label class="bigLabel">{$ls.date}: 
<select name="filters[datefilter]">
<option value="All" {if $filters.datefilter == "All"}selected{/if}>{$ls.all}</option>
<option value="lt" {if $filters.datefilter == "lt"}selected{/if}>&lt;</option>
<option value="gt" {if $filters.datefilter == "gt"}selected{/if}>&gt;</option>
<option value="lteq" {if $filters.datefilter == "lteq"}selected{/if}>&lt;=</option>
<option value="gteq" {if $filters.datefilter == "gteq"}selected{/if}>&gt;=</option>
</select>
</label>
<label class="bigLabel"><input type="text" name="filters[date]" class="divider-dash w8em format-y-m-d" value="{$filters.date|default:"YYYY-MM-DD"}" style="position: relative; top: 0px; width: 97px;" /></label>
<input type="text" name="filters[time]"  style="width: 70px;" value="{$filters.time|default:"HH:MM:SS"}" />
</span>*}

<span id="absoluteDate">
<label class="bigLabel">{$ls.fromDate} <input id="totalUniqueId" type="text" name="filters[fromDate]" class="divider-dash w8em format-y-m-d  no-transparency" value="{$filters.fromDate|default:""}" style="position: relative; top: 0px; width: 97px;" /></label>
<label class="bigLabel">{$ls.toDate} <input id="totalUniqueId2" type="text" name="filters[toDate]" class="divider-dash w8em format-y-m-d  no-transparency" value="{$filters.toDate|default:""}" style="position: relative; top: 0px; width: 97px;" /></label>
</span>

<input type="submit" name="Apply" value="{$ls.applyFilters}" />
<input type="submit" name="Clear" value="{$ls.removeFilters}" /><br />

<p style="text-align: left;"><label class="bigLabel">{$ls.computerName}: </label> 
<select name="filters[computer_search]">
<option value="" {if $filters.computer_search == ""}selected{/if}>{$ls.all}</option>
{section name=cList loop=$computers}
<option value="{$computers[cList].computer_name}" {if $computers[cList].computer_name == $filters.computer_search}selected{/if}>{$computers[cList].computer_name}</option>
{/section}
</select>
<label class="bigLabel">{$ls.taskName}: </label>
<select name="filters[task_search]">
<option value="" {if $filters.task_search == ""}selected{/if}>{$ls.all}</option>

{section name=tList loop=$tasks}
<option value="{$tasks[tList].task_name}" {if $tasks[tList].task_name == $filters.task_search}selected{/if}>{$tasks[tList].task_name}</option>
{/section}
</select>
<label class="bigLabel"><input type="checkbox" value="true" name="filters[excluderescheduled]" {if $filters.excluderescheduled == "true"}checked{/if} /> {$lang.excludeRescheduled}</label>
{*<label class="bigLabel"><input type="checkbox" value="true" onclick="toggleDate(this);" name="filters[absolutedate]" {if $filters.absolutedate == "true"}checked{/if} /> {$lang.absolutedate}</label>*}
</p>
</p>
</form>
</div>

<br style="clear: both;"/>
<div class="window">
  <table class="lister">
  	<tr class="header"><th><a href="?sortby=log_type_id&amp;sorttype={$sorttype}">{$ls.logType} {if $sortby == "log_type_id"}{if $sorttype == "ASC"}<img src="{$fullURL}themes/default/images/desc.gif" alt="DESC" />{else}<img src="{$fullURL}themes/default/images/asc.gif" alt="ASC" />{/if}{/if}</a></th>
  	<th><a href="?sortby=time&amp;sorttype={$sorttype}">{$ls.time} {if $sortby == "time"}{if $sorttype == "ASC"}<img src="{$fullURL}themes/default/images/desc.gif" alt="DESC" />{else}<img src="{$fullURL}themes/default/images/asc.gif" alt="ASC" />{/if}{/if}</a></th>
  	<th><a href="?sortby=status&amp;sorttype={$sorttype}">{$ls.status} {if $sortby == "status"}{if $sorttype == "ASC"}<img src="{$fullURL}themes/default/images/desc.gif" alt="DESC" />{else}<img src="{$fullURL}themes/default/images/asc.gif" alt="ASC" />{/if}{/if}</a></th>
  	<th><a href="?sortby=task_name&amp;sorttype={$sorttype}">{$ls.taskName} {if $sortby == "task_name"}{if $sorttype == "ASC"}<img src="{$fullURL}themes/default/images/desc.gif" alt="DESC" />{else}<img src="{$fullURL}themes/default/images/asc.gif" alt="ASC" />{/if}{/if}</a></th>
  	<th><a href="?sortby=computer_name&amp;sorttype={$sorttype}">{$ls.computerName} {if $sortby == "computer_name"}{if $sorttype == "ASC"}<img src="{$fullURL}themes/default/images/desc.gif" alt="DESC" />{else}<img src="{$fullURL}themes/default/images/asc.gif" alt="ASC" />{/if}{/if}</a></th><th>{$ls.actions}</th></tr>
  	{section name=sld loop=$logs}
    	{assign var=status_id value=$logs[sld].status}
      	<tr class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}">
    	<td class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}" align="center">{$logs[sld].name}</td>
    	<td class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}"  align="center">{$logs[sld].time}</td>
    	<td class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}"  align="center">{$status.$status_id}</td>
    	<td class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}"  align="center"><a href="{$fullURL}tasks/edit/view/{$logs[sld].id}">{$logs[sld].task_name}</a></td>
    	<td class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}"  align="center">{$logs[sld].computer_name}</td>
    	<td class="{if $status_id == 2}reportErrors{/if} {if $status_id == 1}reportWarnings{/if}"  align="center">{if $logs[sld].log_type_id == 4 || $logs[sld].log_type_id == 7 || $logs[sld].log_type_id == 6 || $logs[sld].log_type_id == 5 || $logs[sld].log_type_id == 9}<a href="{$fullUrl}reports/view/report/{$logs[sld].logs_id}">{$ls.viewReport}</a>{else}-{/if}</td>
    	</tr>

  	{/section}
  </table>
  </div>
