<html>
<head>
<title>Add/Modify Rules</title>
<link href="{$fullUrl}themes/{$theme}/styles/sstree.css" rel="stylesheet" type="text/css" />

{literal}
<style type="text/css">
<!--
body {
    margin:0;
    padding:0;
    font: 12px "Verdana";
    background: InfoBackground;
    
}   
div.info2 {
	border-bottom: 1px dotted black;
	padding-left: 15px;
	padding-right: 15px;
	background: InfoBackground;
}
table.filterTable th {
    font-size: 13px;
    width: 40%;
}
table.filterTable {
    width:  100%;
    vertical-align: middle;   
}
table.filterTable input {
    width: 80%;
}
div.lister {
    overflow: auto;
    height: 350px;
    border-bottom: 1px dotted black;
    background: White;
}    
div.footer {
    padding-left: 15px;
    padding-right: 15px;
    background: InfoBackground;
    text-align: center;
    padding-top: 5px;
}
td.user {
    padding-left: 6em;
    background-position: 4.5em top;
}   
td.computer {
    background-image: none;
}
input {
    z-index: 99999;
}    
--> 
</style>
{/literal}
<script src="/themes/{$theme}/javascript/mootools.js" type="text/javascript"></script>
<script src="/themes/{$theme}/javascript/tree.js" type="text/javascript"></script>
<script type="text/javascript">
//onsubmit="window.opener.location.reload();window.close();"
{if $close_window == true}
window.opener.location.pathname = "/tasks/add";
window.close();
{/if}
{literal}
nTree.init();
var computers = new Array();
var workgroups = new Array();
var domains = new Array();
var users = new Array();

function reflectSelections(rowId) {
    parents = getTreeParents($(rowId));
    if (!parents) {
        if ($('d' + rowId).checked == true)
            $(rowId).getElement('td').style.backgroundColor = "#ccffcc";
        else
            $(rowId).getElement('td').style.backgroundColor = "";
        return;
    }

    parents.each(function(el){
        //$(el).style.backgroundColor = "#ccffcc";
        rows = $$('tr');
        for (i=0;i<rows.length;i++) {
            r = rows[i];
            if (matchStart(r.id, rowId, true)) {
                checbox = r.getElementById('d' + r.id);
                if (checbox.checked == true) {
                    $(el).getElement('td').style.backgroundColor = "#ccffcc";
                } else {
                    sl = $$('.selector');
                    deselect = false;
                    sl.each(function(el) {
                        deselect = deselect + el.checked;
                    });
                    if (!deselect)
                    $(el).getElement('td').style.backgroundColor = "";
                }
            }
        }
    });
    if ($('d' + rowId).checked == true)
    $(rowId).getElement('td').style.backgroundColor = "#ccffcc";
    else
     $(rowId).getElement('td').style.backgroundColor = "";

}

function addComputer(computer, rowID, workgroup, parentID) {
    element = $('computer_name');
    pElement = $('workgroup_name');
    if (element.value != "") computers = element.value.split(',');
    fCheckBox = $('d'+rowID);
    
    if (fCheckBox.checked == false) {
        computers.remove(computer);
    } else {
        computers.push(computer);
    }
    
    
    if (!workgroups.test(workgroup) && fCheckBox.checked == true) {
        if (pElement.value != "") workgroups = pElement.value.split(',');
        workgroups.push(workgroup);
        pElement.value = workgroups.join(',');
        $('d'+parentID).checked = true;
    }
    
    
    element.value = computers.join(',');
    reflectSelections(rowID);
}

function addDomain(text,rowId) {
    element = $('domain_name');
    if (element.value != "") domains = element.value.split(',');
    fCheckBox = $('d' + rowId);
    if (fCheckBox.checked == false) {
        domains.remove(text);
    } else {
        domains.push(text)
    }
    element.value = domains.join(',');
    reflectSelections(rowId);
}

function addWorkgroup(text, rowId) {
    element = $('workgroup_name');
    if (element.value != "") workgroups = element.value.split(',');
    fCheckBox = $('d' + rowId);
    if (fCheckBox.checked == false) {
        workgroups.remove(text);
    } else {
        workgroups.push(text)
    }
    element.value = workgroups.join(',');
    reflectSelections(rowId);
}

function addUser(user, rowID, computer, workgroup, cParentID, wParentID) {
    element = $('user_name');
    compElement = $('computer_name');
    workElement = $('workgroup_name');
    
    if (element.value != "") users = element.value.split(',');
    fCheckBox = $('d' + rowID);
    if (fCheckBox.checked == false) {
        users.remove(user);
    } else {
        users.push(user);
    }
    
    if (!workgroups.test(workgroup)) {
        if (workElement.value != "") workgroups = workElement.value.split(',');
        workgroups.push(workgroup);
        workElement.value = workgroups.join(',');
        $('d' + wParentID).checked = true;
    }
    
    if (!computers.test(computer)) {
        if (compElement.value != "") computers = compElement.value.split(',');
        computers.push(computer);
        compElement.value = computers.join(',');
        $('d' + cParentID).checked = true;
    }
    element.value = users.join(',');   
    reflectSelections(rowID);
}

{/literal}
</script>
</head>
<body>
<form action="" method="post" name="applyForm">
<div class="info2">
<table class="filterTable">
<tr><th>Computer Name</th><td><input type="text" name="select[computer_name]" id="computer_name" /></td></tr>
<tr><th>Domain</th><td><input type="text" name="select[domain_name]" id="domain_name" /></td></tr>
<tr><th>Workgroup</th><td><input type="text" name="select[workgroup_name]" id="workgroup_name" /></td></tr>
<tr><th>IP</th><td><input type="text" name="select[ip]" id="ip" /></td></tr>
<tr style="display:none;"><th>Users</th><td><input type="text" name="select[user_name]" id="user_name" /></td></tr>
</table>
</div>
<div class="lister">
<table class="computerWindow">
{foreach name=workloop from=$workgroups item=computers key=workgroup}
<tr id="{$smarty.foreach.workloop.index}">
<td class="collapseable2 tier1 network">
<a href="#" class="collapseableX"><img src="/themes/default/images/plusik.gif" /></a>
<input type="checkbox" class="selector" id="d{$smarty.foreach.workloop.index}" onclick="addWorkgroup('{$workgroup}','{$smarty.foreach.workloop.index}');" /><img src="/themes/default/images/network.png" alt="Network" style="vertical-align:top;"/>{$workgroup}</td>
</tr>
{foreach from=$computers item=users key=computer name=comploop}
<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}">
<td class="computer {if $users|@count > 0}collapseable2{/if} tier2"><img src="/themes/default/images/spacer.gif" width="15" height="19"/>{if $users|@count > 0}<a href="#" class="collapseableX"><img src="/themes/default/images/plusik.gif" /></a>{/if}<input type="checkbox" class="selector" id="d{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}" onclick="addComputer('{$computer}', '{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}', '{$workgroup}', '{$smarty.foreach.workloop.index}');" /><img src="/themes/default/images/computer.png" alt="computer" />{$computer}</td>
</tr>
{if $users|@count > 0}
{foreach from=$users item=user key=id value=uname name=uloop}
<tr id="{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-{$smarty.foreach.uloop.index}">
<td class="user tier2"><input type="checkbox" class="selector" id="d{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-{$smarty.foreach.uloop.index}" onclick="addUser('{$user}', '{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}-{$smarty.foreach.uloop.index}', '{$computer}', '{$workgroup}', '{$smarty.foreach.workloop.index}-{$smarty.foreach.comploop.index}', '{$smarty.foreach.workloop.index}');" /><img src="/themes/default/images/user.png" alt="user" />{$user}</td>
</tr>
{/foreach}
{/if}
{/foreach}
{/foreach}
</table>
</div>
<div class="footer">
<input type="submit" name="save" value="Apply">&nbsp;
<button onclick="window.close();">Cancel</button>
</div>
</form>
</body>
</html>